

# AddFlowSources
<a name="API_AddFlowSources"></a>

 Adds sources to a flow.

## Request Syntax
<a name="API_AddFlowSources_RequestSyntax"></a>

```
POST /v1/flows/flowArn/source HTTP/1.1
Content-type: application/json

{
   "sources": [ 
      { 
         "decryption": { 
            "algorithm": "string",
            "constantInitializationVector": "string",
            "deviceId": "string",
            "keyType": "string",
            "region": "string",
            "resourceId": "string",
            "roleArn": "string",
            "secretArn": "string",
            "url": "string"
         },
         "description": "string",
         "entitlementArn": "string",
         "gatewayBridgeSource": { 
            "bridgeArn": "string",
            "vpcInterfaceAttachment": { 
               "vpcInterfaceName": "string"
            }
         },
         "ingestPort": number,
         "maxBitrate": number,
         "maxLatency": number,
         "maxSyncBuffer": number,
         "mediaStreamSourceConfigurations": [ 
            { 
               "encodingName": "string",
               "inputConfigurations": [ 
                  { 
                     "inputPort": number,
                     "interface": { 
                        "name": "string"
                     }
                  }
               ],
               "mediaStreamName": "string"
            }
         ],
         "minLatency": number,
         "name": "string",
         "ndiSourceSettings": { 
            "sourceName": "string"
         },
         "protocol": "string",
         "routerIntegrationState": "string",
         "routerIntegrationTransitDecryption": { 
            "encryptionKeyConfiguration": { ... },
            "encryptionKeyType": "string"
         },
         "senderControlPort": number,
         "senderIpAddress": "string",
         "sourceListenerAddress": "string",
         "sourceListenerPort": number,
         "sourceTags": { 
            "string" : "string" 
         },
         "streamId": "string",
         "vpcInterfaceName": "string",
         "whitelistCidr": "string"
      }
   ]
}
```

## URI Request Parameters
<a name="API_AddFlowSources_RequestParameters"></a>

The request uses the following URI parameters.

 ** [flowArn](#API_AddFlowSources_RequestSyntax) **   <a name="mediaconnect-AddFlowSources-request-uri-flowArn"></a>
 The Amazon Resource Name (ARN) of the flow that you want to update.  
Pattern: `arn:.+:mediaconnect.+:flow:.+`   
Required: Yes

## Request Body
<a name="API_AddFlowSources_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [sources](#API_AddFlowSources_RequestSyntax) **   <a name="mediaconnect-AddFlowSources-request-sources"></a>
 A list of sources that you want to add to the flow.  
Type: Array of [SetSourceRequest](API_SetSourceRequest.md) objects  
Required: Yes

## Response Syntax
<a name="API_AddFlowSources_ResponseSyntax"></a>

```
HTTP/1.1 201
Content-type: application/json

{
   "flowArn": "string",
   "sources": [ 
      { 
         "connectedRouterOutputArn": "string",
         "dataTransferSubscriberFeePercent": number,
         "decryption": { 
            "algorithm": "string",
            "constantInitializationVector": "string",
            "deviceId": "string",
            "keyType": "string",
            "region": "string",
            "resourceId": "string",
            "roleArn": "string",
            "secretArn": "string",
            "url": "string"
         },
         "description": "string",
         "entitlementArn": "string",
         "gatewayBridgeSource": { 
            "bridgeArn": "string",
            "vpcInterfaceAttachment": { 
               "vpcInterfaceName": "string"
            }
         },
         "ingestIp": "string",
         "ingestPort": number,
         "mediaStreamSourceConfigurations": [ 
            { 
               "encodingName": "string",
               "inputConfigurations": [ 
                  { 
                     "inputIp": "string",
                     "inputPort": number,
                     "interface": { 
                        "name": "string"
                     }
                  }
               ],
               "mediaStreamName": "string"
            }
         ],
         "name": "string",
         "peerIpAddress": "string",
         "routerIntegrationState": "string",
         "routerIntegrationTransitDecryption": { 
            "encryptionKeyConfiguration": { ... },
            "encryptionKeyType": "string"
         },
         "senderControlPort": number,
         "senderIpAddress": "string",
         "sourceArn": "string",
         "transport": { 
            "cidrAllowList": [ "string" ],
            "maxBitrate": number,
            "maxLatency": number,
            "maxSyncBuffer": number,
            "minLatency": number,
            "ndiProgramName": "string",
            "ndiSourceSettings": { 
               "sourceName": "string"
            },
            "ndiSpeedHqQuality": number,
            "protocol": "string",
            "remoteId": "string",
            "senderControlPort": number,
            "senderIpAddress": "string",
            "smoothingLatency": number,
            "sourceListenerAddress": "string",
            "sourceListenerPort": number,
            "streamId": "string"
         },
         "vpcInterfaceName": "string",
         "whitelistCidr": "string"
      }
   ]
}
```

## Response Elements
<a name="API_AddFlowSources_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [flowArn](#API_AddFlowSources_ResponseSyntax) **   <a name="mediaconnect-AddFlowSources-response-flowArn"></a>
 The ARN of the flow that these sources were added to.  
Type: String

 ** [sources](#API_AddFlowSources_ResponseSyntax) **   <a name="mediaconnect-AddFlowSources-response-sources"></a>
 The details of the newly added sources.  
Type: Array of [Source](API_Source.md) objects

## Errors
<a name="API_AddFlowSources_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
This exception is thrown if the request contains a semantic error. The precise meaning depends on the API, and is documented in the error message.   
HTTP Status Code: 400

 ** ForbiddenException **   
You do not have sufficient access to perform this action.   
HTTP Status Code: 403

 ** InternalServerErrorException **   
The server encountered an internal error and is unable to complete the request.   
HTTP Status Code: 500

 ** NotFoundException **   
One or more of the resources in the request does not exist in the system.   
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable or busy.   
HTTP Status Code: 503

 ** TooManyRequestsException **   
The request was denied due to request throttling.   
HTTP Status Code: 429

## See Also
<a name="API_AddFlowSources_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/mediaconnect-2018-11-14/AddFlowSources) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/mediaconnect-2018-11-14/AddFlowSources) 